import time
import math
import sys
import os

import numpy as np
import pandas as pd
import matplotlib.mlab as mlab
import matplotlib.pyplot as plt

import keras
from keras.models import Sequential, Model, model_from_json
from keras.layers import Input, Dense, Dropout, BatchNormalization, merge
from keras import backend as K
from keras import regularizers

import deeplift
import deeplift.conversion.keras_conversion as kc
import deeplift.blobs as blobs
from deeplift.blobs import NonlinearMxtsMode
from deeplift.backend import function as compile_func
from collections import OrderedDict

iterNum = 5;

yvalues = np.empty((0,1), float);
for iter in range(1,iterNum+1):
    y_url = '/home/yanglu/Downloads/deepknock/y_n400_p200_iter' + str(iter) + '.csv';
    yVec = pd.read_csv(y_url, header=None);
    yvalues = np.vstack((yvalues, yVec.values.astype(float)));


X_url = '/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z128_p200/x_itr500000_z2x_knockoff.csv';
xMat = pd.read_csv(X_url, header=None);
xvalues	= xMat.values.astype(float); #print(xvalues.shape);
X_dim = xvalues.shape[1]; n = xvalues.shape[0];

model_url = '/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z128_p200/model_deepRegression_itr500000_z2x_knockoff.h5';
model_json_url = '/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z128_p200/model_deepRegression_itr500000_z2x_knockoff.json';
weight_url = '/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z128_p200/featWeight_itr500000_z2x_knockoff.csv';


def getModel():
    model = Sequential()

    #model.add(Dense(1, activation='linear', bias=False, init='glorot_normal', W_regularizer=regularizers.l1(100.0), input_dim=X_dim))

    model.add(Dense(128, activation='relu', bias=True, init='glorot_normal', input_dim=X_dim))
    model.add(Dense(64, activation='relu', bias=True, init='glorot_normal'))
    model.add(Dense(32, activation='relu', bias=True, init='glorot_normal'))
    model.add(Dense(1, init='glorot_normal'))
    model.compile(loss='mse', optimizer = 'adam')
    return model

model = getModel();
model.summary()

model.fit(xvalues, yvalues, nb_epoch=50, batch_size=100)

#get_layer_output = K.function([model.layers[0].input, K.learning_phase()],[model.layers[-1].output])
#np.set_printoptions(threshold=np.inf)
#print(get_layer_output([xvalues, 0])[0].T)


deeplift_model = kc.convert_sequential_model(model=model, nonlinear_mxts_mode=NonlinearMxtsMode.DeepLIFT_GenomicsDefault)
deeplift_contribs_func = deeplift_model.get_target_multipliers_func(find_scores_layer_idx=0, target_layer_idx=-1)
scores = np.array(deeplift_contribs_func(task_idx=0, input_data_list=[xvalues], batch_size=100, progress_update=None))
scores = pd.DataFrame(scores)

print("scorres:")
print(scores)
np.savetxt(weight_url, scores, delimiter=",", fmt='%.4f');


#model_json = model.to_json()
#with open(model_json_url, "w") as json_file:
#    json_file.write(model_json)
#model.save_weights(model_url)
#print("Saved model to disk")

#predicted = model.predict(xvalues)
#print(predicted);
#print(yvalues)