
setwd("/home/yanglu/Downloads/RANK/")
source('/home/yanglu/Downloads/RANK/gknockoff_all.R')
source('/home/yanglu/Downloads/RANK/isee_all.R')

# load packages
require(graphics)
library(igraph)
library(MASS) 
library(Matrix)
library(pracma)

n = 400;
p = 200;
z_dim = 128;
iter = 1; 
q = 0.2;

regfactor = "log"
npermu = 5
sis.use = 0
bia.cor = 0

beta.true = c(rep(0, p))
S.true = c(1:30)
beta.true[S.true] = c(1,-1,1,-1,1,-1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1)

xURL = paste("/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr500000.csv",sep="")
xAllURL = paste("/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr500000_z2x_knockoff.csv",sep="")
#xURL = paste("/home/yanglu/Downloads/deepknock/out_wbigan_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr400000.csv",sep="")
#xAllURL = paste("/home/yanglu/Downloads/deepknock/out_wbigan_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr400000_z2x_knockoff.csv",sep="")
#xURL = paste("/home/yanglu/Downloads/deepknock/out_wgangp_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr400000.csv",sep="")
#xAllURL = paste("/home/yanglu/Downloads/deepknock/out_wgangp_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr400000_z2x_knockoff.csv",sep="")
#xURL = paste("/home/yanglu/Downloads/deepknock/out_wgan_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr400000.csv",sep="")
#xAllURL = paste("/home/yanglu/Downloads/deepknock/out_wgan_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/x_itr400000_z2x_knockoff.csv",sep="")

print(xAllURL)

x <- read.csv(xURL, header = FALSE, sep = ",")
X_all <- read.csv(xAllURL, header = FALSE, sep = ",")

yURL = paste("/home/yanglu/Downloads/deepknock/y_n",toString(n),"_p",toString(p),"_iter",toString(iter),".csv",sep="")
y <- data.matrix(read.csv(yURL, header = FALSE, sep = ","))


n1 <- nrow(x); #print(paste("n=",toString(nrow(x))))
p1 <- ncol(x); #print(paste("p=",toString(ncol(x))))

n1 <- nrow(X_all); #print(paste("n1=",toString(n1)))
p1 <- ncol(X_all); #print(paste("p1=",toString(p1)))


for (iter in 1:1)
{

print(paste("iter=",toString(iter)))
Xnew = data.matrix(X_all[((iter-1)*n):(iter*n),])
Xnew1 = data.matrix(X_all[((iter-1)*n):(iter*n),])

for(rowIdx in 0:(n-1))
{
for(colIdx in 0:(p-1))
{
        Xnew1[rowIdx:rowIdx+1,colIdx:colIdx+1] <- x[rowIdx:rowIdx+1,colIdx:colIdx+1]
}
}


obj1 = slassotf(Xnew, y, regfactor, sis.use = 0)
betap.stan = obj1$betap.stan

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)

rm(Xnew,obj1,betap.stan,W,t,ratio,id,T,S,fdp,tdp)


obj1 = slassotf(Xnew1, y, regfactor, sis.use = 0)
betap.stan = obj1$betap.stan

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)

rm(Xnew1,obj1,betap.stan,W,t,ratio,id,T,S,fdp,tdp)
}



