
setwd("/home/yanglu/Downloads/RANK/")
source('/home/yanglu/Downloads/RANK/gknockoff_all.R')
source('/home/yanglu/Downloads/RANK/isee_all.R')

# load packages
require(graphics)
library(igraph)
library(MASS) 
library(Matrix)
library(pracma)


regfactor = "log"
npermu = 5
sis.use = 0
bia.cor = 0

n = 400;
p = 200;
z_dim = 128;
iter = 1; 
#q = 0.1;

beta.true = c(rep(0, p))
S.true = c(1:30)
beta.true[S.true] = c(1,-1,1,-1,1,-1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1)

weightURL = paste("/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/featWeight9_itr500000_z2x_knockoff.csv",sep="")
print(weightURL)
weightMat <- read.csv(weightURL, header = FALSE, sep = ",")

n1 <- nrow(weightMat); print(paste("n=",toString(nrow(weightMat))))
p1 <- ncol(weightMat); print(paste("p=",toString(ncol(weightMat))))


for(q in c(0.2,0.1,0.05))
{
print("==========================================================")
print(paste("q= ", toString(q), sep=" "))

print("L1===========================\n")
weightMat <- abs(weightMat)
tmp = colSums(as.matrix(weightMat));
betap.stan = unlist((tmp))

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)


print("L2===========================\n")
weightMat <- weightMat^2
tmp = colSums(as.matrix(weightMat));
betap.stan = sqrt(unlist((tmp)))

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)

print("Square===========================\n")
tmp = colSums(as.matrix(weightMat));
betap.stan = unlist((tmp))

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)

}
