
setwd("/home/yanglu/Downloads/RANK/")
source('/home/yanglu/Downloads/RANK/gknockoff_all.R')
source('/home/yanglu/Downloads/RANK/isee_all.R')

# load packages
require(graphics)
library(igraph)
library(MASS) 
library(Matrix)
library(pracma)


regfactor = "log"
npermu = 5
sis.use = 0
bia.cor = 0

n = 400;
p = 200;
z_dim = 128;
# iter = 3; 
repAll = 10;

beta.true = c(rep(0, p))
S.true = c(1:30)
beta.true[S.true] = c(1,-1,1,-1,1,-1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1,1,-1,1,-1,1,-1,1,1,-1,1)

qList = c(0.2,0.1,0.05)


for (iter in 1:12) {

resultMat = matrix(0, repAll, 6*length(qList));

for( repNum in 1:repAll ) {

weightURL = paste("/home/yanglu/Downloads/deepknock/out_wbigangp_Sphr1Gaus1_BNTrue_z",toString(z_dim),"_p",toString(p),"/featWeight", toString(iter), "_itr500000_z2x_knockoff_rep",toString(repNum),".csv",sep="")
print(weightURL)
weightMat <- read.csv(weightURL, header = FALSE, sep = ",")

if(ncol(weightMat) == 1) {
weightMat = t(weightMat)
}

n1 <- nrow(weightMat); p1 <- ncol(weightMat); 

print(n1)
print(p1)

qIdx = 0;
for(q in qList) {

print("L1===========================\n")
weightMat1 <- abs(weightMat)
tmp = colSums(as.matrix(weightMat1));
betap.stan = unlist((tmp))

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)
resultMat[repNum,6*qIdx+1] = fdp;
resultMat[repNum,6*qIdx+2] = tdp;

print("L2===========================\n")
weightMat1 <- weightMat^2
tmp = colSums(as.matrix(weightMat1));
betap.stan = sqrt(unlist((tmp)))

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)
resultMat[repNum,6*qIdx+3] = fdp;
resultMat[repNum,6*qIdx+4] = tdp;

print("Square===========================\n")
tmp = colSums(as.matrix(weightMat1));
betap.stan = unlist((tmp))

W = c(rep(0, p))
for (j in 1:p) {
  W[j] = abs(betap.stan[j]) - abs(betap.stan[j+p])
}

t = sort(c(0, abs(W)))
ratio = c(rep(0, p))
for (j in 1:p) {
  ratio[j] = sum(W <= -t[j])/max(1, sum(W >= t[j]))
}
id = which(ratio <= q)[1]
if(length(id) == 0){
  T = Inf
} else {
  T = t[id]
}

S = which(W >= T); print(S)
fdp = fdr(S, beta.true); print(fdp)
tdp = pow(S, beta.true); print(tdp)
resultMat[repNum,6*qIdx+5] = fdp;
resultMat[repNum,6*qIdx+6] = tdp;


qIdx = qIdx + 1;
}

}

print(resultMat)
write.table(resultMat, file = paste("/home/yanglu/Downloads/RANK/result_featWeight", toString(iter),".csv",sep=""), sep =",", row.names=FALSE, col.names=FALSE)

}
